#include "CBg.hpp"
#include "CSystem.hpp"

#include <assert.h>

CBg::CBg(const char *path)
{
	SDL_Surface *image_bmp;
	
	printf("Budu nahravat obrazek %s\n", path);
	image_bmp = SDL_LoadBMP(path);
	if (image_bmp == NULL) {
		CSystem::problemSDL();
	}
		
	// pro urychleni vykreslovani
	mPas = SDL_DisplayFormat(image_bmp);
	SDL_FreeSurface(image_bmp);

	mPosun = 0;
}	

CBg::~CBg()
{
	SDL_FreeSurface(mPas);
}

/*
* kresli posuvny pas pozadi
*/
void
CBg::draw(SDL_Surface *surface)
{
	SDL_Rect source;
	SDL_Rect dest;

	// nejlepe je surface->w == mPas->w
	assert(surface->w == mPas->w && surface->h <= mPas->h);
			
	dest.x = 0;
	dest.y = mPosun;
	// pozn. SDL_BlitSurface osetruje presahy pres okraj,
	// tudiz nedojde k Segmentation fault
	SDL_BlitSurface(mPas, NULL, surface, &dest);

	dest.x = 0;
   	dest.y = 0;
	source.x = 0;
	source.y = mPas->h - mPosun;
	source.w = surface->w;
	source.h = mPosun;
	SDL_BlitSurface(mPas, &source, surface, &dest);

	mPosun++;
	if (mPosun >= mPas->h) {
		mPosun = 0;
	}
}

	
	
	
	
