#include "CBody_lod.hpp"

#include "CSystem.hpp"
	
// zvuk vybuchu
Mix_Chunk *CBody_lod::sVybuch = NULL;

CBody_lod::CBody_lod() {
	// inicializuje soubor se zvukem
	if (sVybuch == NULL) {
		sVybuch = CSystem::loadWav("body/lod.wav");
	}
}
	
/*
* provedeni narazu
* odecte se sila protivnika
* vraci true jesli jsme mrtvi
*/
inline
	bool 
CBody_lod::crash(int power)
{
	mPower -= power;
	
	if (mPower <= 0) {
		// prehraj vybuch
		Mix_PlayChannel(-1, sVybuch, 0);
		return true;
	}
	return false;
}

/*
* zobrazeni ukazatele energosky
* nakresli se barevna carecka pod lodi
*/
void 
CBody_lod::showPower(SDL_Surface *surface, double x, double y) 
{	
	// tloustka prouzku
	static const int height = 5;
	SDL_Rect rect;
	// sirka prouzku (zdraveho)
	int width = mVzhled_up->w;
	int umisteniY = mPulH;
	
	rect.w = width * mPower / mInitPower;
	rect.h = height;
	rect.x = static_cast<int>(x) - rect.w / 2;
	if (mUp) {
		rect.y = static_cast<int>(y) + umisteniY;
	} else {
		// zde musime jeste odecist tloustku prouzku
		rect.y = static_cast<int>(y) - umisteniY - height;
	}

	// nakresleni vyplneneho obdelniku (barvou zadanou RGB)
	SDL_FillRect(surface, &rect, SDL_MapRGB(surface->format, 255 * (mInitPower - mPower) / mInitPower, 255 * mPower / mInitPower, 0));
}	

