#include "CCarrier.hpp"

#include <assert.h>

// roztec mezi dvema zbranemi
const double CCarrier::sRoztec = 20;

//-----------------------------------------------------------------------------
CCarrier::~CCarrier() 
{
	// uvolneni vsech zbrani
	for (store_t::iterator i = mSklad.begin(); i != mSklad.end(); i++) {
		delete (*i);
	}
}
//-----------------------------------------------------------------------------
fleet_t *
CCarrier::shot(CXY *ship, Uint32 ticks, CXY *target) 
{
	fleet_t *salva;
	fleet_t *naboje = NULL;
	double posuv = ship->getX() - mNalevo;

	for (store_t::iterator i = mSklad.begin(); i != mSklad.end(); i++) {
		salva = (*i)->shot(posuv, ship->getY(), ticks, target);
		if (salva != NULL) {
			if (naboje == NULL) {
				naboje = salva;
			} else {
				naboje->insert( naboje->begin(), salva->begin(), salva->end() );
				delete salva;
			}
		}

		posuv += sRoztec;
	}

	return naboje;
}	
//-----------------------------------------------------------------------------
	void
CCarrier::draw(SDL_Surface *surface, double x, double y)
{
	double posuv = x - mNalevo;

	for (store_t::iterator i = mSklad.begin(); i != mSklad.end(); i++) {
		(*i)->draw(surface, posuv, y);
		posuv += sRoztec;
	}
}
//-----------------------------------------------------------------------------
/*
* pridavani zbrani pri vytvareni nove lodi
*/
	void
CCarrier::addWeapon(CWeapon *weapon) 
{
	assert(weapon != NULL);
	store_t::iterator stred = mSklad.begin(); 
	
	mNalevo = (mSklad.size() * sRoztec) / 2.0;	
	// vypocteme stred mezi zbranemi
	for (unsigned int i = 0; i < mSklad.size() / 2; i++) {
		stred++;
	}
	
	mSklad.insert(stred, weapon);
}


/*
* vyloupeni skladu nabourane lodi
*/
void 
CCarrier::addSklad(CCarrier *sklad, bool up)
{
	// otoceni vzhledu 
	for (store_t::iterator i = sklad->mSklad.begin(); i != sklad->mSklad.end(); i++) {
		(*i)->changeUp(up);
	}

	// vypocteme stred mezi zbranemi
	store_t::iterator stred = mSklad.begin(); 
	for (unsigned int i = 0; i < mSklad.size() / 2; i++) {
		stred++;
	}

	mSklad.insert(stred, sklad->mSklad.begin(), sklad->mSklad.end());	
	// vymazeme druhe lodi sklad,
	// ale protoze to jsou jen ukazatele,
	// samotnych zbrani se to nedotkne
	sklad->mSklad.clear();
	
	mNalevo = ((mSklad.size() -1) * sRoztec) / 2.0;	
}
