#include "CShip.hpp"

#include <assert.h>

//-------------------------------------------------------------------------
CShip::CShip(double x, double y, bool up, CBody *body, CMove *move, CFire *fire)
{
	mX = x;
	mY = y;
	mUp = up;

	assert(body != NULL);
	assert(move != NULL);
	assert(fire != NULL);

	mBody = body;
	mMove = move;
	mFire = fire;

	mBody->changeUp(mUp);
	mCarrier = new CCarrier();
}
//-------------------------------------------------------------------------
CShip::~CShip()
{
	delete mBody;
	delete mMove;
	delete mFire;
	delete mCarrier;
}

//-------------------------------------------------------------------------
	void
CShip::addWeapon(CWeapon *weapon)
{
	assert(weapon != NULL);

	weapon->changeUp(mUp);
	mCarrier->addWeapon(weapon);
}

//-------------------------------------------------------------------------
	void
CShip::draw(SDL_Surface *surface) 
{	
	// nakresleni nosice
	mBody->draw(surface, mX, mY);
	// nakresleni zbrane
	mCarrier->draw(surface, mX, mY);
	// nakresleni ukazatele energosky
	mBody->showPower(surface, mX, mY);
}		

//-------------------------------------------------------------------------
	bool
CShip::letMove(Uint8 *keys, double deltaTime, CXY *target)   
{
	// zaroven bude regenerovat
	mBody->recovery(deltaTime);
	// pohyb
	return mMove->move(this, keys, deltaTime, target);
}
//-------------------------------------------------------------------------
	fleet_t *
CShip::letFire(Uint8 *keys, Uint32 ticks, CXY *target) 
{
	return mFire->fire(this, mCarrier, keys, ticks, target);
}


//-------------------------------------------------------------------------
/*
* provedeni narazu
 */
	bool 
CShip::crash(int power) 
{
	return mBody->crash(power);
}

/*
* vyloupeni zbrani z nabourane lodi
 */	
	void 
CShip::loot(CShip *korist)
{
	mCarrier->addSklad(korist->mCarrier, mUp);
}
