/*
* class Ship
* univerzalni lod
 */
#ifndef CSHIP_HPP
#define CSHIP_HPP

#include "CXY.hpp"
#include "CBody.hpp"
#include "CFire.hpp"
#include "CMove.hpp"
#include "CCarrier.hpp"

#include "SDL.h"

class CShip : public CXY {
	// zda leti nahoru
	bool mUp;

	// strukturalni integrita
	class CBody *mBody;
	// ovladani pohybu
	class CMove *mMove;
	// ovladani strileni
	class CFire *mFire;	

	// zbranova vybava
	CCarrier *mCarrier;

	public:
	CShip(double x, double y, bool up, CBody *body, CMove *move, CFire *fire);
	~CShip();
	void addWeapon(CWeapon *weapon);
	   	
	void draw(SDL_Surface *surface);
	bool letMove(Uint8 *keys, double deltaTime, CXY *target);
	fleet_t *letFire(Uint8 *keys, Uint32 ticks, CXY *target);

	bool crash(int power);
	void loot(CShip *korist);
	
	int getPulW() { return mBody->getPulW(); }
	int getPulH() { return mBody->getPulH(); }

	int getPower() { return mBody->getPower(); }
	bool getUp() { return mUp; }

	void setXY(double newX, double newY) {
		mX = newX;
		mY = newY;
	}
};


#endif
/* eof */
