#include "CSystem.hpp"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

// staticky prvek, spusti se konstructor CSRand()
CSRand CSystem::initRandom = CSRand();

//----------------------------------------------------------
CSRand::CSRand() {
	// incializace generatoru nahodnych cisel
	CSystem::echo("Inicializuji generator nahodnych cisel ...");
	srand( static_cast<unsigned>(time(NULL)) );
}
//----------------------------------------------------------



/*
* ohleseni chyby a konec
*/
void
CSystem::problemSDL() 
{
	fprintf(stderr, "Problem: %s\n", SDL_GetError());
	exit(1);
}

void
CSystem::echo(const char *text) 
{
	fprintf(stderr, "%s\n", text);
}
	

/*
* nahraje obrazek z BMP souboru, nastavi mu transparentni barvu
* a prevede do rychleji zobrazovaneho formatu
*/
SDL_Surface *
CSystem::loadImage(const char *path)
{
	SDL_Surface *image_bmp;
	SDL_Surface *surface;

	printf("Budu nahravat obrazek %s\n", path);

	image_bmp = SDL_LoadBMP(path);
	if (image_bmp == NULL) {
		// vynadani a konec
		CSystem::problemSDL();
	}
	
	// nastaveni transparentni barvy (bude to ta co je v levem hornim rohu)
	CSystem::setColorKey(image_bmp);

	
	// pro urychleni vykreslovani se prevede do zobrazovane formy
	surface = SDL_DisplayFormat(image_bmp);
	SDL_FreeSurface(image_bmp);
	return surface;	
}

/* 
* nacteni zvuku
 */
	Mix_Chunk *
CSystem::loadWav(const char *path) 
{
	Mix_Chunk *wav;

	printf("Budu nahravat wav %s\n", path);
	wav = Mix_LoadWAV(path);
	if (wav == NULL) {
		CSystem::problemSDL();
	}
	return wav;
}

/*
* nastavi transparetni barvu rovnou barve v levem hornim rohu
 */
	void 
CSystem::setColorKey(SDL_Surface *surface)
{
	Uint32 colorKey;

	switch(surface->format->BitsPerPixel)
	{
		case 8:
			colorKey = *static_cast<Uint8 *>(surface->pixels);
			SDL_SetColorKey(surface, SDL_SRCCOLORKEY, colorKey);
			break;
		case 16:
			colorKey = *static_cast<Uint16 *>(surface->pixels);
			SDL_SetColorKey(surface, SDL_SRCCOLORKEY, colorKey);
			break;
		case 24:
		case 32:
			colorKey = *static_cast<Uint32 *>(surface->pixels);
			SDL_SetColorKey(surface, SDL_SRCCOLORKEY, colorKey);
			break;
		default:
			break;
	}
}

/*
* vraci nahodne cislo mezi z <0,mez)
* (bere ho z vyssich bitu)
 */
	int
CSystem::random(int mez) 
{
	return rand() % mez;
}
