#include "CWeapon_cannon.hpp"
#include "CSystem.hpp"
#include "CBody_shot.hpp"
#include "CFire.hpp"
#include "CMove_linear.hpp"

#include <assert.h>

// definice constantnich clenu
// sVelShot ... rychlost strely
const int CWeapon_cannon::sVelShot = 300;
// kolik milisekund je potreba ne jednu strelu
// 1000/4 ... 4 strely za sekundu
const Uint32 CWeapon_cannon::sFireTime = 1000 / 4;
	

// definice statickych clenu
SDL_Surface *CWeapon_cannon::sVzhled_up = NULL;
SDL_Surface *CWeapon_cannon::sVzhled_down = NULL;

//---------------------------------------------------------------------
CWeapon_cannon::CWeapon_cannon() 
{
	if (sVzhled_up == NULL) {
		sVzhled_up = CSystem::loadImage("weapon/cannon_up.bmp");
		sVzhled_down = CSystem::loadImage("weapon/cannon_down.bmp");
		
		assert(sVzhled_up->w == sVzhled_down->w && sVzhled_up->h == sVzhled_down->h);
	}
	// mLastFire ... kdy se naposled vystrelilo
	mLastFire = 0;
	
	mVzhled_up = sVzhled_up;
	mVzhled_down = sVzhled_down;	
	initRozmery();
}

/*
* vystreleni strely
* vraci se seznam strel (lodi)
*/
	fleet_t *
CWeapon_cannon::shot(double x, double y, Uint32 ticks, CXY *target)
{
	if (ticks - mLastFire >= sFireTime) {
		// vytvoreni nove strely
		double vystrelY;
		CMove *move;
		CBody *body = new CBody_shot();
		CFire *fire = new CFire();
		mLastFire = ticks;
		
		if (mUp) {
			move = new CMove_linear(0, -sVelShot);	
			vystrelY = y - mPulH;
		} else {
			move = new CMove_linear(0, +sVelShot);	
			vystrelY = y + mPulH;
		}	
		
		// vytvorime seznam o jednom naboji,
		// constructorem ktery vytvori '1' kopiji prvku
		return new fleet_t(1, new CShip( x , vystrelY, mUp, body, move, fire) );
	}
	
	return NULL;	
}


