#include "CWeapon_fork.hpp"
#include "CSystem.hpp"
#include "CBody_shot.hpp"
#include "CFire.hpp"
#include "CMove_linear.hpp"

#include <assert.h>

// definice constantnich clenu
// sVelShot ... rychlost strely
const int CWeapon_fork::sVelShot = 250;
// kolik milisekund je potreba ne jednu strelu
// 1000/4 ... 4 strely za sekundu
const Uint32 CWeapon_fork::sFireTime = 1000 / 3;
	

// definice statickych clenu
SDL_Surface *CWeapon_fork::sVzhled_up = NULL;
SDL_Surface *CWeapon_fork::sVzhled_down = NULL;

//---------------------------------------------------------------------
CWeapon_fork::CWeapon_fork() 
{
	if (sVzhled_up == NULL) {		
		sVzhled_up = CSystem::loadImage("weapon/fork_up.bmp");
		sVzhled_down = CSystem::loadImage("weapon/fork_down.bmp");
		
		assert(sVzhled_up->w == sVzhled_down->w && sVzhled_up->h == sVzhled_down->h);
	}
	// mLastFire ... kdy se naposled vystrelilo
	mLastFire = 0;
	
	mVzhled_up = sVzhled_up;
	mVzhled_down = sVzhled_down;	
	initRozmery();
}

/*
* vystreleni strely
* vraci se seznam strel (lodi)
*/
	fleet_t *
CWeapon_fork::shot(double x, double y, Uint32 ticks, CXY *target)
{
	if (ticks - mLastFire >= sFireTime) {
		// vytvoreni novych strel
		fleet_t *salva;
		double vystrelY;
		CMove *move1, *move2;
		mLastFire = ticks;
		
		if (mUp) {
			move1 = new CMove_linear(+sVelShot, -sVelShot);	
			move2 = new CMove_linear(-sVelShot, -sVelShot);	
			vystrelY = y - mPulH;
		} else {
			move1 = new CMove_linear(+sVelShot, +sVelShot);	
			move2 = new CMove_linear(-sVelShot, +sVelShot);	
			vystrelY = y + mPulH;
		}	
		
		// vytvorime seznam naboju
		salva = new fleet_t();
		salva->push_front( new CShip( x , vystrelY, mUp, new CBody_shot(), move1, new CFire()) );
		salva->push_front( new CShip( x , vystrelY, mUp, new CBody_shot(), move2, new CFire()) );
		return salva;
	}
	
	return NULL;	
}


