#include "CWeapon_magnet.hpp"
#include "CSystem.hpp"
#include "CBody_shot.hpp"
#include "CFire.hpp"
#include "CMove_linear.hpp"

#include <assert.h>
#include <math.h>

// definice constantnich clenu
// sVelShot ... rychlost strely
const int CWeapon_magnet::sVelShot = 150;
// kolik milisekund je potreba ne jednu strelu
// 1000/4 ... 4 strely za sekundu
const Uint32 CWeapon_magnet::sFireTime = 1000 / 2;
	

// definice statickych clenu
SDL_Surface *CWeapon_magnet::sVzhled_up = NULL;
SDL_Surface *CWeapon_magnet::sVzhled_down = NULL;

//---------------------------------------------------------------------
CWeapon_magnet::CWeapon_magnet() 
{
	if (sVzhled_up == NULL) {		
		sVzhled_up = CSystem::loadImage("weapon/magnet_up.bmp");
		sVzhled_down = CSystem::loadImage("weapon/magnet_down.bmp");
		
		assert(sVzhled_up->w == sVzhled_down->w && sVzhled_up->h == sVzhled_down->h);
	}
	// mLastFire ... kdy se naposled vystrelilo
	mLastFire = 0;
	
	mVzhled_up = sVzhled_up;
	mVzhled_down = sVzhled_down;	
	initRozmery();
}

/*
* vystreleni strely
* vraci se seznam strel (lodi)
*/
	fleet_t *
CWeapon_magnet::shot(double x, double y, Uint32 ticks, CXY *target)
{
	if (ticks - mLastFire >= sFireTime && target != NULL) {
		// vytvoreni novych strel
		fleet_t *salva;
		double vystrelY;
		CMove *move1;
		double magnet_x, magnet_y;
		double absHodnota;
		
		mLastFire = ticks;				

		// vypocteme vektor pro strelbu
		magnet_x = target->getX() - x; 
		magnet_y = target->getY() - y;
		// hypot(x,y) vrati sqrt(x*x + y*y)
		absHodnota = hypot(magnet_x, magnet_y);
		magnet_x = sVelShot * magnet_x / absHodnota;
		magnet_y = sVelShot * magnet_y / absHodnota;
		move1 = new CMove_linear(magnet_x, magnet_y);	
		
		if (mUp) {
			vystrelY = y - mPulH;
		} else {
			vystrelY = y + mPulH;
		}	
		
		// vytvorime seznam naboju
		salva = new fleet_t();
		salva->push_front( new CShip( x , vystrelY, mUp, new CBody_shot(), move1, new CFire()) );
		return salva;
	}
	
	return NULL;	
}


